package com.flow.entity.node.trigger;

import com.flow.flowable.utils.ProcessElementUtil;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.flowable.bpmn.model.ServiceTask;

import java.util.Map;

@EqualsAndHashCode(callSuper = true)
@Data
public class ClassTrigger extends Trigger {
    private String implementationType;
    private String implementation;
    private Map<String, String> params;

    @Override
    public void initImpl(ServiceTask serviceTask) {
        serviceTask.setImplementationType(this.implementationType);
        serviceTask.setImplementation(this.implementation);
        for (String key : params.keySet()) {
            ProcessElementUtil.setFieldExtensionExpression(serviceTask, key, params.get(key));
        }
    }
}
