package com.flow.entity.node.trigger;

import com.fasterxml.jackson.annotation.JsonSubTypes;
import com.fasterxml.jackson.annotation.JsonTypeInfo;
import lombok.Data;
import org.flowable.bpmn.model.ServiceTask;

@Data
@JsonTypeInfo(use = JsonTypeInfo.Id.NAME, property = "type", defaultImpl = Trigger.class, visible = true)
@JsonSubTypes({
        @JsonSubTypes.Type(value = MqTrigger.class, name = "mq"),
        @JsonSubTypes.Type(value = HttpTrigger.class, name = "http"),
        @JsonSubTypes.Type(value = MicroTrigger.class, name = "micro"),
        @JsonSubTypes.Type(value = ClassTrigger.class, name = "class")
})
public abstract class Trigger {
    private TriggerType type;

    public abstract void initImpl(ServiceTask serviceTask);
}
